// Header File
// Created 5/18/2005; 3:23:16 PM

typedef struct
{
  char *theName;
  int (*getKeyFunc)();
  int meaning;
} MMENUITEM;

typedef struct
{
  int x,y,endX;
  int numOfItems;
  MMENUITEM *theMenuItems;
} MMENU;

int stdMenu()
{
  return ngetchx();
}

void invertMenuItem(int x,int y,int endX)
{
  FillBox(x,y,endX,y+9,A_XOR);
}

void updateMIString(MMENU *theMenu,long theItem)
{
	FillBox(theMenu->x,theMenu->y+theItem*10,theMenu->endX,theMenu->y+theItem*10+9,A_REVERSE);
  DrawStr(theMenu->x,theMenu->y+theItem*10,theMenu->theMenuItems[theItem].theName,A_NORMAL);
  invertMenuItem(theMenu->x,theMenu->y+theItem*10,theMenu->endX);
}

void changeMIString(MMENU *theMenu,long theItem,const char *newText)
{
  theMenu->theMenuItems[theItem].theName=(char*)newText;
  updateMIString(theMenu,theItem);
}

int runMenu(MMENU theMenu,int *menuResponse)
{
  int i,k;
  FontSetSys(F_8x10);
  FillBox(theMenu.x,theMenu.y,theMenu.endX,theMenu.y+theMenu.numOfItems*10-1,A_REVERSE);
  for (i=0;i<theMenu.numOfItems;i++)
  {
    DrawStr(theMenu.x,theMenu.y+i*10,theMenu.theMenuItems[i].theName,A_NORMAL);
  }
  i=*menuResponse;
  if (i<0) i=0;
  else if (i>=theMenu.numOfItems) i=theMenu.numOfItems-1;
  while (1)
  {
    invertMenuItem(theMenu.x,theMenu.y+i*10,theMenu.endX);
    k=theMenu.theMenuItems[i].getKeyFunc(theMenu.x,theMenu.y+i*10,theMenu.endX);
    invertMenuItem(theMenu.x,theMenu.y+i*10,theMenu.endX);
    if (k==KEY_ENTER)
    {
    	*menuResponse=i;
    	return theMenu.theMenuItems[i].meaning;
    }
    if (k==KEY_ESC)
    {
    	*menuResponse=d_EXIT;
    	return d_EXIT;
    }
    if (k==KEY_DOWN)
    {
      i++;
      if (i>=theMenu.numOfItems) i=0;
    }
    else if (k==KEY_UP)
    {
      i--;
      if (i<0) i=theMenu.numOfItems-1;
    }
  }
}