// Header File
// Created 5/17/2005; 1:48:43 PM

ETURN *findPossibleTurns(EBOARD *theBoard,long *numOfTurns)
{
  int x,y,t;
  ETURN *ret;
  ETURN *ptr;
  ETURN tbuffer;
  *numOfTurns=0;
  for (y=0;y<theBoard->yDim;y++)
  for (x=0;x<theBoard->xDim;x++)
  {
    if (theBoard->board[x+y*theBoard->xDim].player==theBoard->curTurn)
    {
      for (t=0;t<8;t++)
      {
        tbuffer.startX=x;
        tbuffer.startY=y;
        tbuffer.dir=t;
        if (legalMove(theBoard,&tbuffer)) *numOfTurns++;
      }
    }
  }
  ret=malloc(*numOfTurns*sizeof(ETURN));
  ptr=ret;
  for (y=0;y<theBoard->yDim;y++)
  for (x=0;x<theBoard->xDim;x++)
  {
    if (theBoard->board[x+y*theBoard->xDim].player==theBoard->curTurn)
    {
      for (t=0;t<8;t++)
      {
        tbuffer.startX=x;
        tbuffer.startY=y;
        tbuffer.dir=t;
        if (legalMove(theBoard,&tbuffer)) *(ptr++)=tbuffer;
      }
    }
  }
  return ret;
}

long findBestAttack(EBOARD *theBoard,ETURN *turns,long numOfTurns)
{
  long i;
  long c;
  long ci;
  EBOARD virtBoard;
  int scoreTemp[2];
  int *thisScore=scoreTemp;
  int oldScore;
  getScores(theBoard,scoreTemp,scoreTemp+1);
  if (theBoard->curTurn==BLACK) thisScore++;
  oldScore=*thisScore;
  c=-1;
  ci=0;
  for (i=0;i<numOfTurns;i++)
  {
    virtBoard=*theBoard;
    processTurn(theBoard,turns+i);
    getScores(theBoard,scoreTemp,scoreTemp+1);
    if (*thisScore>oldScore)
    	if (ci<*thisScore-oldScore)
    	{
    		ci=*thisScore-oldScore;
    		c=i;
    	}
  }
  return c;
}

/*long findImportantLoneSupport(EBOARD *theBoard,ETURN *turns,long numOfTurns)
{
  
}

long findClosestHold(EBOARD *theBoard,ETURN *turns,long numOfTurns)
{
  
}*/

ETURN aiMove(EBOARD *theBoard)
{
  long numOfTurns;
  ETURN *turns=findPossibleTurns(theBoard,&numOfTurns);
  ETURN retTurn={-1,-1,-1};
  long tindex;
  if (!numOfTurns) return retTurn;
  tindex=findBestAttack(theBoard,turns,numOfTurns);
  if (tindex>=0) goto takeTurn;
  //tindex=findImportantLoneSupport(theBoard,turns,numOfTurns);
  if (tindex>=0) goto takeTurn;
  //tindex=findClosestHold(theBoard,turns,numOfTurns);
takeTurn:
  retTurn=turns[tindex];
  free(turns);
  return retTurn;
}